#!/usr/bin/env python

import struct
import mmap
import time

import gtk
import pygtk
import gobject

try:
    import osso
except ImportError:
    osso = None

v1disp = [
"39 39 25 1",
". c #101010",
"@ c #ffffff",

"a c #ff0000",
"b c #ff0000",
"c c #ff0000",
"d c #ff0000",
"e c #ff0000",
"f c #ff0000",
"g c #ff0000",
"p c #ff0000",
"1 c #ff0000",
"2 c #ff0000",
"3 c #ff0000",
"4 c #ff0000",
"5 c #ff0000",
"6 c #ff0000",
"7 c #ff0000",
"8 c #ff0000",
"u c #ff0000",
"s c #ff0000",
"r c #ff0000",
"k c #ff0000",
"q c #ff0000",
"l c #ff0000",
"x c #ff0000",

".......................................",
".......................................",
".......................................",
".......................................",
".......................................",
".......................................",
".......................................",
"...aaaaaaaaaa..@...lll.................",
"..f.aaaaaaaa.b.@...lll........uu.......",
"..ff........bb.@@@.lll.......uuuu......",
"..ff........bb..............uuuuuu.....",
"..ff........bb.............uuuuuuuu....",
"..ff........bb..@..qqq....uuuuuuuuuu...",
"..ff........bb.@@@.qqq...uuuuuuuuuuuu..",
"..ff........bb.@.@.qqq.....uuuuuuuu....",
"..ff........bb.............uuuuuuuu....",
"..ff........bb.............uuuuuuuu....",
"..fggggggggggb.@.@.kkk...s..........s..",
"..eggggggggggc.@@..kkk..ssssssssssssss.",
"..ee........cc.@.@.kkk.ssssssssssssssss",
"..ee........cc..........ssssssssssssss.",
"..ee........cc...........s..........s..",
"..ee........cc.@.@.xxx.....rrrrrrrr....",
"..ee........cc..@..xxx.....rrrrrrrr....",
"..ee........cc.@.@.xxx...rrrrrrrrrrrr..",
"..ee........cc.............rrrrrrrr....",
"..ee........cc..ppp..........rrrr......",
"..e.dddddddd.c..ppp....................",
"...dddddddddd...ppp....................",
".......................................",
"...888.777.666.555.444.333.222.111.....",
"...888.777.666.555.444.333.222.111.....",
"...888.777.666.555.444.333.222.111.....",
".......................................",
".......................................",
".......................................",
".......................................",
".......................................",
"......................................."
               ]
v1prev = 0
button = None
disp = None

def updatev1():
    global v1prev, button, disp
    gobject.timeout_add(25,updatev1)
    v1state = struct.unpack("i",data)
    if v1state[0] == v1prev:
        return;

    if disp:
        disp.display_state_on()

    v1prev = v1state[0]
    max = 33
    mute = (v1prev >> (max-2)) & 1;

    sege = (v1prev >> (max-3)) & 1;
    segd = (v1prev >> (max-4)) & 1;
    segc = (v1prev >> (max-5)) & 1;
    segb = (v1prev >> (max-6)) & 1;
    sega = (v1prev >> (max-7)) & 1;
    segg = (v1prev >> (max-17)) & 1;
    segf = (v1prev >> (max-18)) & 1;
    segdp = (v1prev >> (max-8)) & 1;
    str1 = (v1prev >> (max-9)) & 1;
    str2 = (v1prev >> (max-10)) & 1;
    str3 = (v1prev >> (max-11)) & 1;
    str4 = (v1prev >> (max-12)) & 1;
    str5 = (v1prev >> (max-13)) & 1;
    str6 = (v1prev >> (max-14)) & 1;
    str7 = (v1prev >> (max-15)) & 1;
    str8 = (v1prev >> (max-16)) & 1;
    radk = (v1prev >> (max-19)) & 1;
    radka = (v1prev >> (max-20)) & 1;
    laser = (v1prev >> (max-21)) & 1;
    fronta = (v1prev >> (max-22)) & 1;
    sidea = (v1prev >> (max-25)) & 1;
    reara = (v1prev >> (max-28)) & 1;
    radx = (v1prev >> (max-32)) & 1;

    if sega:
        v1disp[3] = "a c #ff0000"
    else:
        v1disp[3] = "a c #300000"
    if segb:
        v1disp[4] = "b c #ff0000"
    else:
        v1disp[4] = "b c #300000"
    if segc:
        v1disp[5] = "c c #ff0000"
    else:
        v1disp[5] = "c c #300000"

    if segd:
        v1disp[6] = "d c #ff0000"
    else:
        v1disp[6] = "d c #300000"
    if sege:
        v1disp[7] = "e c #ff0000"
    else:
        v1disp[7] = "e c #300000"
    if segf:
        v1disp[8] = "f c #ff0000"
    else:
        v1disp[8] = "f c #300000"

    if segg:
        v1disp[9] = "g c #ff0000"
    else:
        v1disp[9] = "g c #300000"
    if segdp:
        v1disp[10] = "p c #ff0000"
    else:
        v1disp[10] = "p c #300000"

    if str1:
        v1disp[11] = "1 c #ff0000"
    else:
        v1disp[11] = "1 c #300000"
    if str2:
        v1disp[12] = "2 c #ff0000"
    else:
        v1disp[12] = "2 c #300000"

    if str3:
        v1disp[13] = "3 c #ff0000"
    else:
        v1disp[13] = "3 c #300000"
    if str4:
        v1disp[14] = "4 c #ff0000"
    else:
        v1disp[14] = "4 c #300000"

    if str5:
        v1disp[15] = "5 c #ff0000"
    else:
        v1disp[15] = "5 c #300000"
    if str6:
        v1disp[16] = "6 c #ff0000"
    else:
        v1disp[16] = "6 c #300000"

    if str7:
        v1disp[17] = "7 c #ff0000"
    else:
        v1disp[17] = "7 c #300000"
    if str8:
        v1disp[18] = "8 c #ff0000"
    else:
        v1disp[18] = "8 c #300000"
    if radk:
        v1disp[19] = "k c #ff0000"
    else:
        v1disp[19] = "k c #300000"

    if radx:
        v1disp[20] = "x c #ff0000"
    else:
        v1disp[20] = "x c #300000"
    if laser:
        v1disp[21] = "l c #ff0000"
    else:
        v1disp[21] = "l c #300000"
    if radka:
        v1disp[22] = "q c #ff0000"
    else:
        v1disp[22] = "q c #300000"

    if fronta:
        v1disp[23] = "u c #ff0000"
    else:
        v1disp[23] = "u c #300000"
    if sidea:
        v1disp[24] = "s c #ff0000"
    else:
        v1disp[24] = "s c #300000"
    if reara:
        v1disp[25] = "r c #ff0000"
    else:
        v1disp[25] = "r c #300000"
        
    pixbuf = gtk.gdk.pixbuf_new_from_xpm_data(v1disp)
    image = gtk.Image()
    w = button.get_allocation().width
    h = button.get_allocation().height
    if w > h:
        w = h
    image.set_from_pixbuf(pixbuf.scale_simple(w,w,gtk.gdk.INTERP_NEAREST))
    button.set_image(image)


file = open("/tmp/v1state", "r+")

data = mmap.mmap(file.fileno(), 4)

v1prev = 0

if osso:
    osso_c = osso.Context("osso_display_on", "0.0.1", False)
    disp = osso.DeviceState(osso_c)

window = gtk.Window(gtk.WINDOW_TOPLEVEL)
window.connect("destroy", lambda wid: gtk.main_quit())
window.connect("delete_event", lambda a1,a2:gtk.main_quit())
window.set_title("Valentine V1")

button = gtk.Button()
button.set_image(gtk.image_new_from_stock(gtk.STOCK_YES, gtk.ICON_SIZE_MENU))
button.set_name("menu")
button.set_size_request(320,320)
button.show()

window.add(button)
window.show()

gobject.timeout_add(25,updatev1)
gtk.main()
